﻿Imports System.Drawing.Drawing2D
Imports System.IO
Imports System.Threading

'***************************************************************************
'*** Sorgente tutelato da Licenza GNU GPL V3 ***
'***************************************************************************
'*** Gioco del 2048 realizzato da *** Tebaldo Ulleri *** in Data 12-Aprile-2018
'***************************************************************************
'*** Developers: Tebaldo Ulleri, Carlo Barabucci, Michele Cannavo
'***************************************************************************
Public Class Form1

#Region "Variabili_Globali_del_Gioco"

    '***********************************************************************
    'Variabili globali
    Public TipoGrafica As Short = My.Settings.Immagini_Set ' da 1 a 8

    Public InMovimento As Boolean
    Public Tempo As Date ' tempo trascorso
    Public Partenza As Date = DateTime.Now  ' data e ora di inizio gioco
    Public AutoOn As Boolean = False
    Public Move_R As Boolean
    Public Move_L As Boolean
    Public Move_U As Boolean
    Public Move_D As Boolean
    Public Mosse_Auto As Boolean
    Public Audio_On As Boolean
    Public Animazione_On As Boolean
    Public Mat4x4Pict_2040() As PictureBox = {}
    Public Matrice4x4(4, 4) As Integer
    Public Matrice_Back1(4, 4) As Integer
    Public Potenze_del_2() As Int32 = {2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048, 4096, 8192, 16384}
    Public Stato_eventi As Int32
    Public Punteggio As Int32
    Public Punti_Mossa As Int32
    Public mosse As Int32
    Public Record As Int32
    Public Indx_Nuovo_Val As String
    Public Max_Potenza_Raggiunta As Int32 = 0 'modifica Ultimo 11-7-2018 ore 24
    Public Ultima_Potenza As Int32 = 0
    Public Scambio_ok As Boolean
    Public Scambio_ok_Back As Boolean
    Public Obiettivi_Punteggio() As Int32 = {2048, 4096, 8192, 16384, 32768, 65536}
    Public Scelta_Colori As New List(Of Color)
    Public countSetImm As Short
    Public RigaLetta() As String
    Public Registra_Partita As Boolean

    ' Suono1.
    Dim Suono1 = New System.Media.SoundPlayer("C:\Windows\Media\chord.wav")

    ' Suono2.
    Dim Suono2 = New System.Media.SoundPlayer("C:\Windows\Media\tada.wav")

    ' Suono3.
    Dim Suono3 = New System.Media.SoundPlayer("C:\Windows\Media\notify.wav")

    ' Suono4.
    ' Inserire in Resources una musica di tipo WAV e richiamarla quà sotto in My.Resources........
    Dim Suono4 = New System.Media.SoundPlayer(My.Resources.win)

    ' Suono5.
    ' Inserire in Resources una musica di tipo WAV e richiamarla quà sotto in My.Resources........
    Dim Suono5 = New System.Media.SoundPlayer(My.Resources.VGOMyMove)

    '***********************************************************************

#End Region

#Region "Costruttore e procedure di avvio e chiusura gioco "

    ' Costruttore
    Sub New()
        ' Chiamata richiesta dalla finestra di progettazione.

        InitializeComponent()

        ' Aggiungere le eventuali istruzioni di inizializzazione dopo la chiamata a InitializeComponent().
        Me.Animazione1ToolStrip.Checked = My.Settings.Animazione_1
        Me.Animazione2ToolStrip.Checked = My.Settings.Animazione_2
        Me.Animazione3ToolStrip.Checked = My.Settings.Animazione_3

        ' se no settings (primo uso del programma), carico dati di default
        If TipoGrafica <> 1 _
            And TipoGrafica <> 2 _
            And TipoGrafica <> 3 _
            And TipoGrafica <> 4 _
            And TipoGrafica <> 5 _
            And TipoGrafica <> 6 _
            And TipoGrafica <> 7 _
            And TipoGrafica <> 8 _
        Then TipoGrafica = 2

        If Me.Animazione1ToolStrip.Checked = False _
        And Me.Animazione2ToolStrip.Checked = False _
        And Me.Animazione3ToolStrip.Checked = False _
        Then Me.Animazione1ToolStrip.Checked = True

        Animazione_On = True
        Audio_On = True
        Registra_Partita = False
        RS = False

        Lbl_Diff.Text = "Diff: Media"

        Scelta_Colori.Add(Color.Blue)   'index 0
        Scelta_Colori.Add(Color.Bisque)
        Scelta_Colori.Add(Color.DarkGray)
        Scelta_Colori.Add(Color.DarkKhaki)
        Scelta_Colori.Add(Color.Brown)
        Scelta_Colori.Add(Color.Brown)
        Scelta_Colori.Add(Color.DarkGreen)
        Scelta_Colori.Add(Color.Navy)
        Scelta_Colori.Add(Color.Navy)   'index 8

        Timer1.Enabled = True

    End Sub

    Private Sub Form1_Shown(sender As Object, e As EventArgs) Handles Me.Shown
        Me.Focus()
    End Sub

    Private Sub Form1_2048_Game_Load(sender As Object, e As EventArgs) Handles Me.Load
        Nuovo_Record = False
        Scambio_ok = True
        Scambio_ok_Back = True
        Mosse_Auto = True
        Win = False
        Move_R = False
        Move_L = False
        Move_U = False
        Move_D = False

        Call CheckDirectory()
        Call Crea_Simboli(TipoGrafica)
        Call Inizializza_Matrice2048(Matrice4x4)
        Stato_eventi = Stato.Azzerato
        Call CreaSchema4X4Classic2048()
        Call Gestione_Difficolta_Livello(Difficoltà.Media)
        Me.Text = "2048 The Game v." & My.Application.Info.Version.ToString
        Me.TextBox_Nome.BackColor = Color.Yellow
        InMovimento = False
        'chiedo di immettere il nome
        Call LoginForm1.ShowDialog()
    End Sub

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
        Messaggio.Show()
        Messaggio.WindowState = FormWindowState.Normal
        e.Cancel = True
        Me.Enabled = False

        My.Settings.Save()
    End Sub

#End Region

#Region "Comandi manuali e Interfaccia Menù del Gioco"

    Private Sub Avvia_Click(sender As Object, e As EventArgs) Handles ButtonAvvia.Click
        'modificato da Ultimo il 5-7-2018 ore 12
        If Stato_eventi = Stato.Azzerato Then
            Call Inizializza_Matrice2048(Matrice4x4)
            Call Random_Matrice4x4_2048()
            Call Visualizza_Immagine_Celle2048(Matrice4x4)
            Call Copia_Matrice2048(Matrice4x4, Matrice_Back1)
            InMovimento = False
            Me.ButtonAvvia.Enabled = False
            ButtRivedi.BackgroundImage = My.Resources.buttRivediBW
            ButtRivedi.Text = ""
            ButtonAvvia.Text = "in play "
            'Modificato da Mikelius il 10-07-2018 alle 01.36
            ' Blocca le modifiche ai radio Button durante la partitia
            GroupBox1.Enabled = False
        End If
    End Sub

    Private Sub ButtAzzera_Click(sender As Object, e As EventArgs) Handles ButtAzzera.Click
        AzzeraToolStripMenuItem_Click(0, New System.EventArgs())
    End Sub

    Private Sub ButtRegistra_Click(sender As Object, e As EventArgs) Handles ButtRegistra.Click
        Call RegistraPartitaOnOffToolStrip_Click(0, New System.EventArgs())
    End Sub

    Private Sub ButtHallOfFame_Click(sender As Object, e As EventArgs) Handles ButtHallOfFame.Click
        Call CheckDirectory()
        'RS = True '------------- Ultimo 11-7-2018 ore 23
        Classifica_Gioco = New Holl_Of_Fame
        Call Classifica_Gioco.Show()
        Me.Enabled = False
    End Sub

    Private Sub But_UP_Click(sender As Object, e As EventArgs) Handles But_UP.Click
        If InMovimento Or Stato_eventi = Stato.Rivedi Then Exit Sub ' se l'animazione è in corso non eseguo
        Move_U = Consenso_Mosse(Matrice4x4, "U")
        If Move_U = True Then
            Call Copia_Matrice2048(Matrice4x4, Matrice_Back1)
            Scambio_ok_Back = Scambio_ok
            Stato_eventi = Stato.Avviato
            'riattivo il timer1
            If Win Then Timer1.Enabled = True : Win = False
        End If
        Scambio_ok = False
        Call Elabora_Matrice4x4_UP(Matrice4x4)
        If Scambio_ok = True Then
            Call Random_Matrice4x4_2048()
            InMovimento = True  ' evita errore
            Call Visualizza_Immagine_Celle2048(Matrice4x4)
            InMovimento = False ' evita errore
            Call cambia_colore_P(sender)
        Else
            Call verifica_Mosse(Matrice4x4)
        End If
    End Sub

    Private Sub But_Down_Click(sender As Object, e As EventArgs) Handles But_Down.Click
        If InMovimento Or Stato_eventi = Stato.Rivedi Then Exit Sub ' se l'animazione è in corso non eseguo
        Move_D = Consenso_Mosse(Matrice4x4, "D")
        If Move_D = True Then
            Call Copia_Matrice2048(Matrice4x4, Matrice_Back1)
            Scambio_ok_Back = Scambio_ok
            Stato_eventi = Stato.Avviato
            'riattivo il timer1
            If Win Then Timer1.Enabled = True : Win = False
        End If
        Scambio_ok = False
        Call Elabora_Matrice4x4_Down(Matrice4x4)
        If Scambio_ok = True Then
            Call Random_Matrice4x4_2048()
            InMovimento = True ' evita errore
            Call Visualizza_Immagine_Celle2048(Matrice4x4)
            InMovimento = False ' evita errore
            Call cambia_colore_P(sender)
        Else
            Call verifica_Mosse(Matrice4x4)
        End If
    End Sub

    Private Sub But_R_Click(sender As Object, e As EventArgs) Handles But_R.Click
        If InMovimento Then Exit Sub ' se l'animazione è in corso non eseguo
        If Stato_eventi = Stato.Rivedi Then
            mosse += 1
            If mosse > HScrollBar1.Maximum Then mosse = HScrollBar1.Maximum
            Scorre_Matrice(mosse, AnimazioneOnoffToolStrip.Checked)
            Return
        End If
        Move_R = Consenso_Mosse(Matrice4x4, "R")
        If Move_R = True Then
            Call Copia_Matrice2048(Matrice4x4, Matrice_Back1)
            Scambio_ok_Back = Scambio_ok
            Stato_eventi = Stato.Avviato
            'riattivo il timer1
            If Win Then Timer1.Enabled = True : Win = False
        End If
        Scambio_ok = False
        Call Elabora_Matrice4x4_Right(Matrice4x4)
        If Scambio_ok = True Then
            Call Random_Matrice4x4_2048()
            InMovimento = True ' evita errore
            Call Visualizza_Immagine_Celle2048(Matrice4x4)
            InMovimento = False ' evita errore
            Call cambia_colore_P(sender)
        Else
            Call verifica_Mosse(Matrice4x4)
        End If
    End Sub

    Private Sub But_L_Click(sender As Object, e As EventArgs) Handles But_L.Click
        If InMovimento Then Exit Sub ' se l'animazione è in corso non eseguo
        If Stato_eventi = Stato.Rivedi Then
            mosse -= 1
            If mosse < 1 Then mosse = 0
            Scorre_Matrice(mosse, AnimazioneOnoffToolStrip.Checked)
            Return
        End If
        Move_L = Consenso_Mosse(Matrice4x4, "L")
        If Move_L = True Then
            Call Copia_Matrice2048(Matrice4x4, Matrice_Back1)
            Scambio_ok_Back = Scambio_ok
            Stato_eventi = Stato.Avviato
            'riattivo il timer1
            If Win Then Timer1.Enabled = True : Win = False
        End If
        Scambio_ok = False
        Call Elabora_Matrice4x4_Left(Matrice4x4)
        If Scambio_ok = True Then
            Call Random_Matrice4x4_2048()
            InMovimento = True ' evita errore
            Call Visualizza_Immagine_Celle2048(Matrice4x4)
            InMovimento = False ' evita errore
            Call cambia_colore_P(sender)
        Else
            Call verifica_Mosse(Matrice4x4)
        End If
    End Sub

    Public Sub Back1PassoToolStrip_Click(sender As Object, e As EventArgs) Handles Back1PassoToolStrip.Click
        If Stato_eventi = Stato.Azzerato Or Stato_eventi = Stato.Back1Passo Or Stato_eventi = Stato.Rivedi Or Back_Bonus < 1 Then
            Exit Sub
        End If
        'aggiorna i bonus
        Back_Bonus -= 1 : Butt_1PassoBack.Text = Back_Bonus.ToString
        Call Copia_Matrice2048(Matrice_Back1, Matrice4x4)
        Call Visualizza_Immagine_Celle2048(Matrice4x4)
        Scambio_ok = Scambio_ok_Back
        mosse -= 1
        Punteggio -= Punti_Mossa
        Me.TSLabel_Stato.Text = "Stato: Punteggio " & Punteggio & "   Mosse " & mosse
        InMovimento = False
        Stato_eventi = Stato.Back1Passo
    End Sub

    'Funzione per i comandi da tastiera
    Protected Overrides Function ProcessCmdKey(ByRef msg As Message, ByVal keyData As Keys) As Boolean
        If InMovimento = True Then
            Return True
        End If
        ' Intercetto le frecce
        Select Case keyData
            Case Keys.P
                Avvia_Click(ButtonAvvia, New System.EventArgs())
            Case Keys.Down
                But_Down.Focus()
                But_Down_Click(But_Down, New System.EventArgs())
            Case Keys.Up
                But_UP.Focus()
                But_UP_Click(But_UP, New System.EventArgs())
            Case Keys.Left
                But_L.Focus()
                But_L_Click(But_L, New System.EventArgs())
            Case Keys.Right
                But_R.Focus()
                But_R_Click(But_R, New System.EventArgs())
            Case Keys.D0
                AzzeraToolStripMenuItem_Click(0, New System.EventArgs())
            Case Keys.Escape
                EsciToolStripMenuItem_Click(0, New System.EventArgs())
            Case Keys.F4
                EsciToolStripMenuItem_Click(0, New System.EventArgs())
            Case Keys.Z
                Back1PassoToolStrip_Click(0, New System.EventArgs())
            Case Keys.V
                Call VisualizzaTest_Immagini() 'mostra i simboli correnti
            Case Keys.H
                Animazione1ToolStrip_Click(1, New System.EventArgs())
            Case Keys.J
                Animazione2ToolStrip_Click(2, New System.EventArgs())
            Case Keys.K
                Animazione3ToolStrip_Click(3, New System.EventArgs())
            Case Keys.D1
                Call ImmSet_Click(1)
            Case Keys.D2
                Call ImmSet_Click(2)
            Case Keys.D3
                Call ImmSet_Click(3)
            Case Keys.D4
                Call ImmSet_Click(4)
            Case Keys.D5
                Call ImmSet_Click(5)
            Case Keys.D6
                Call ImmSet_Click(6)
            Case Keys.D7
                Call ImmSet_Click(7)
            Case Keys.D8
                Call ImmSet_Click(8)
            Case Keys.F1
                GuidaToolStripMenuItem_Click(0, New System.EventArgs())
            Case Keys.F12
                Me.Enabled = False
                Credits.Show()
            Case Keys.Add
                If Me.NumericUpDown1.Value < Me.NumericUpDown1.Maximum Then
                    Me.NumericUpDown1.Value += 1
                End If
            Case Keys.Subtract
                If Me.NumericUpDown1.Value > Me.NumericUpDown1.Minimum Then
                    Me.NumericUpDown1.Value -= 1
                End If
            Case Keys.F10
                Call HallOfFameToolStrip_Click(0, New System.EventArgs())
            Case Keys.R
                Call RegistraPartitaOnOffToolStrip_Click(0, New System.EventArgs())
            Case Keys.S
                Call AudioOnOffToolStrip_Click(0, New System.EventArgs())
            Case Keys.A
                Call AnimazioneOnoffToolStrip_Click(0, New System.EventArgs())
                ' aggiunto Carlo 12-07-2018 evento break
            Case Keys.B
                If Stato_eventi = Stato.Avviato Then FormBreak.Show()
        End Select

        keyData = Nothing
        Return True

    End Function

    'Funzione per i comandi Touch
    Private Sub Touch_Input(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If (Me.Panel1 IsNot Nothing) Then

        End If
    End Sub

    Public Sub AzzeraToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles AzzeraToolStripMenuItem.Click
        Stato_eventi = Stato.Azzerato
        Punteggio = 0
        Punti_Mossa = 0
        mosse = 0
        Nuovo_Record = False
        Max_Potenza_Raggiunta = 0
        Ultima_Potenza = 0 'modificato da Ultimo 11-7-2018 ore 01
        Obiettivi_Punteggio = {2048, 4096, 8192, 16384, 32768, 65536} ' ripristino
        Me.TextBox_Nome.Text = Giocatore
        Call Inizializza_Matrice2048(Matrice4x4)
        Call Visualizza_Immagine_Celle2048(Matrice4x4)
        Scambio_ok = True
        InMovimento = False
        Me.ButtonAvvia.Enabled = True
        Me.ButtonAvvia.Text = "PLAY "
        Me.ButtRivedi.BackgroundImage = My.Resources.buttRivedi
        Me.ButtRivedi.Text = "rivedi"
        Animazione_On = AnimazioneOnoffToolStrip.Checked
        ' aggiunto Carlo 7-7-2018 ore 11 ---------------------------
        Me.ButtRegistra.Text = RegistraPartitaOnOffToolStrip.Checked
        '-----------------------------------------------------------
        But_UP.Visible = True
        But_Down.Visible = True
        Me.Text = "2048 The Game v." & My.Application.Info.Version.ToString
        RS = False
        Timer1.Enabled = True
        Me.HScrollBar1.Visible = False
        Me.TSLabel_Stato.Text = "Stato: Punteggio " & Punteggio & "   Mosse " & mosse
        ' Modifica di Mikelius il 10-07-2018
        ' Ripermette la modifica dei RadioButton
        GroupBox1.Enabled = True
        ' aggiunto carlo 12-7-2018 ore 17
        ' ripristina i bonus in base alla difficoltà corrente
        Gestione_Difficolta_Livello(Livello_Diff)
    End Sub

    Private Sub EsciToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles EsciToolStripMenuItem.Click
        Messaggio.Show()
        Messaggio.WindowState = FormWindowState.Normal
        My.Settings.Save()
        Me.Enabled = False
    End Sub

    Private Sub TextBox_Nome_Click(sender As Object, e As EventArgs) Handles TextBox_Nome.Click
        'inserimento nome giocatore
        Me.Enabled = False
        LoginForm1.Show()
    End Sub

    Private Sub AboutToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles AboutToolStripMenuItem.Click
        Credits.Show()
        Me.Enabled = False
    End Sub

    Private Sub Animazione1ToolStrip_Click(sender As Object, e As EventArgs) Handles Animazione1ToolStrip.Click
        Me.Animazione1ToolStrip.Checked = True
        Me.Animazione2ToolStrip.Checked = False
        Me.Animazione3ToolStrip.Checked = False
        My.Settings.Animazione_1 = True
        My.Settings.Animazione_2 = False
        My.Settings.Animazione_3 = False
    End Sub

    Private Sub Animazione2ToolStrip_Click(sender As Object, e As EventArgs) Handles Animazione2ToolStrip.Click
        Me.Animazione2ToolStrip.Checked = True
        Me.Animazione1ToolStrip.Checked = False
        Me.Animazione3ToolStrip.Checked = False
        My.Settings.Animazione_2 = True
        My.Settings.Animazione_1 = False
        My.Settings.Animazione_3 = False
    End Sub

    Private Sub Animazione3ToolStrip_Click(sender As Object, e As EventArgs) Handles Animazione3ToolStrip.Click
        Me.Animazione3ToolStrip.Checked = True
        Me.Animazione1ToolStrip.Checked = False
        Me.Animazione2ToolStrip.Checked = False
        My.Settings.Animazione_3 = True
        My.Settings.Animazione_1 = False
        My.Settings.Animazione_2 = False
    End Sub

    Private Sub VediSetimmaginiToolStrip_Click(sender As Object, e As EventArgs) Handles VediSetimmaginiToolStrip.Click
        Call VisualizzaTest_Immagini()
    End Sub

    Private Sub AnimazioneOnoffToolStrip_Click(sender As Object, e As EventArgs) Handles AnimazioneOnoffToolStrip.Click
        Animazione1ToolStrip.Enabled = AnimazioneOnoffToolStrip.Checked
        Animazione2ToolStrip.Enabled = AnimazioneOnoffToolStrip.Checked
        Animazione3ToolStrip.Enabled = AnimazioneOnoffToolStrip.Checked

        Call ButtAnimazione_Click(sender, e)
    End Sub

    Private Sub AudioOnOffToolStrip_Click(sender As Object, e As EventArgs) Handles AudioOnOffToolStrip.Click
        Call ButtAudio_Click(sender, e)
    End Sub

    Private Sub GuidaToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles GuidaToolStripMenuItem.Click
        If File.Exists(Application.StartupPath & "\Risorse\Guida\2048 The Game 9.6.chm") Then
            Process.Start(Application.StartupPath & "\Risorse\Guida\2048 The Game 9.6.chm")
        End If
    End Sub

    Private Sub AvviaToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles AvviaToolStripMenuItem.Click
        If Stato_eventi = Stato.Avviato Then Return
        Call Me.Avvia_Click(sender, e)
    End Sub

    Private Sub Butt_1PassoBack_Click(sender As Object, e As EventArgs) Handles Butt_1PassoBack.Click
        Call Back1PassoToolStrip_Click(sender, e)
    End Sub

    Private Sub Form1_MouseWheel(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseWheel
        ' aggiunto Mikelius
        ' .Delta è la proprietà che indica di quanto è stata ruotata la rotellina
        If e.Delta > 0 Then
            countSetImm += 1
            'La rotellina è stata ruotata verso l'alto
        ElseIf e.Delta < 0 Then
            countSetImm -= 1
            'La rotellina è stata ruotata verso il basso
        End If
        '  MessageBox.Show(Math.Abs(countSetImm) Mod 8)
        Call ImmSet_Click(Math.Abs(countSetImm Mod 8) + 1)
    End Sub

    Private Sub ImmaginiSet_Click(sender As Object, e As EventArgs) Handles ImmaginiSet1ToolStrip.Click,
        ImmaginiSet2ToolStrip.Click, ImmaginiSet3ToolStrip.Click, ImmaginiSet4ToolStrip.Click,
        ImmaginiSet5ToolStrip.Click, ImmaginiSet6ToolStrip.Click, ImmaginiSet7ToolStrip.Click, ImmaginiSet8ToolStrip.Click

        countSetImm = Convert.ToInt16(sender.tag)
        Call ImmSet_Click(countSetImm)
    End Sub

    Private Sub ImmSet_Click(Ind As Integer)
        TipoGrafica = Ind
        My.Settings.Immagini_Set = TipoGrafica
        My.Settings.Save()
        Call Crea_Simboli(TipoGrafica)
        For j = 1 To 16
            Mat4x4Pict_2040(j).BackColor = Scelta_Colori(TipoGrafica)
        Next
        Call Visualizza_Immagine_Celle2048(Matrice4x4)
        InMovimento = False
    End Sub

    Friend Sub HallOfFameToolStrip_Click(sender As Object, e As EventArgs) Handles HallOfFameToolStrip.Click
        Call CheckDirectory()
        'RS = True  '-------------- Ultimo 11-7-2018 ore 23
        Classifica_Gioco = New Holl_Of_Fame
        Call Classifica_Gioco.Show()
        Me.Enabled = False
    End Sub

    Private Sub ResettaRecordToolStrip_Click(sender As Object, e As EventArgs) Handles ResettaRecordToolStrip.Click
        If Stato_eventi = Stato.Azzerato Then
            My.Settings.Record = 2000
            My.Settings.Mosse_Rec = 100
            My.Settings.Nome = "Pippo"
            My.Settings.Max_Valore = 128
            My.Settings.Save()

            Label1.Text = "Punteggio Record: " & My.Settings.Record
            Label2.Text = "Mosse: " & My.Settings.Mosse_Rec
            Label3.Text = "Record di: " & My.Settings.Nome
            Label4.Text = "Max_Val: " & My.Settings.Max_Valore
        End If
    End Sub

    ' Modificato Carlo Mikelius 11-07-2018 ore 17 ------------------------------------------------------------------
    Private Sub ButtAutocompletamento_Click(sender As Object, e As MouseEventArgs) Handles ButtAutocompletamento.MouseDown
        Dim Attuale As Byte = NumericUpDown1.Value
        If e.Button = MouseButtons.Left Then
            Attuale = Attuale Mod 8 + 1
        ElseIf e.Button = MouseButtons.Right Then
            Attuale = Attuale - 1
            If Attuale < 1 Then Attuale = 8
        End If
        NumericUpDown1.Value = Attuale
    End Sub

    Private Sub NumericUpDown1_ValueChanged(sender As Object, e As EventArgs) Handles NumericUpDown1.ValueChanged
        ButtAutocompletamento.Text = NumericUpDown1.Value.ToString
    End Sub

    Private Sub ButtAnimazione_Click(sender As Object, e As EventArgs) Handles ButtAnimazione.Click
        ' Modificato Carlo 7-7-2018 ore 11 --------------------------------
        Animazione_On = Not Animazione_On
        If Animazione_On Then
            ButtAnimazione.BackgroundImage = My.Resources.buttAnimazioneOn
        Else
            ButtAnimazione.BackgroundImage = My.Resources.buttAnimazioneOff
        End If
        AnimazioneOnoffToolStrip.Checked = Animazione_On
        '------------------------------------------------------------------
    End Sub

    Private Sub ButtAudio_Click(sender As Object, e As EventArgs) Handles ButtAudio.Click
        ' Modificato Carlo 7-7-2018 ore 11 ----------------------
        Audio_On = Not Audio_On
        If Audio_On Then
            ButtAudio.BackgroundImage = My.Resources.buttAudioOn
        Else
            ButtAudio.BackgroundImage = My.Resources.buttAudioOff
        End If
        AudioOnOffToolStrip.Checked = Audio_On
        '--------------------------------------------------------
    End Sub

#End Region

#Region "Funzioni e Procedure  per i movimenti e azioni del gioco"

    Enum Stato
        Azzerato 'index 0
        Avviato
        Completato
        Errato
        Back1Passo
        Rivedi   'index 5
    End Enum

    Public Function Consenso_Mosse(ByRef Matr2048 As Int32(,), ByVal Direz As String) As Boolean
        Dim consenso As Boolean = False
        Select Case Direz
            Case Is = "U"
                For c As Int32 = 1 To 3
                    For r As Int32 = 4 To 1 Step -1
                        If Matr2048(c, r) = Matr2048(c + 1, r) And Matr2048(c, r) > 1 Then
                            consenso = True
                        End If

                        If Matr2048(c, r) = 1 And Matr2048(c + 1, r) > 1 Then
                            consenso = True
                        End If
                    Next r
                Next c

            Case Is = "L"
                For R = 1 To 4
                    For C = 1 To 3
                        If Matr2048(R, C) = Matr2048(R, C + 1) And Matr2048(R, C) > 1 Then
                            consenso = True
                        End If

                        If Matr2048(R, C) = 1 And Matr2048(R, C + 1) > 1 Then
                            consenso = True
                        End If
                    Next C
                Next R

            Case Is = "D"
                For c As Int32 = 4 To 2 Step -1
                    For r As Int32 = 1 To 4
                        If Matr2048(c, r) = 1 And Matr2048(c - 1, r) > 1 Then
                            consenso = True
                        End If

                        If Matr2048(c, r) = Matr2048(c - 1, r) And Matr2048(c, r) > 1 Then
                            consenso = True
                        End If
                    Next r
                Next c

            Case Is = "R"
                For r As Int32 = 1 To 4
                    For c As Int32 = 4 To 2 Step -1
                        If Matr2048(r, c) = 1 And Matr2048(r, c - 1) > 1 Then
                            consenso = True
                        End If

                        If Matr2048(r, c) = Matr2048(r, c - 1) And Matr2048(r, c) > 1 Then
                            consenso = True
                        End If
                    Next c
                Next r

        End Select

        Return consenso
    End Function

    Public Sub Verifica_Ultima_Potenza(ByVal P As Int32)
        Ultima_Potenza = P
        If Ultima_Potenza > Max_Potenza_Raggiunta Then Max_Potenza_Raggiunta = Ultima_Potenza Else Return
        Dim index As Int32 = Array.IndexOf(Obiettivi_Punteggio, Max_Potenza_Raggiunta)

        If index >= 0 Then
            If Stato_eventi = Stato.Avviato Then Win = True
            '----------------------------------------------
            My.Computer.Audio.Play(My.Resources.win, AudioPlayMode.Background)
            Thread.Sleep(200)
            Dim Congr As New Congratulazioni(Max_Potenza_Raggiunta)
            Call Congr.Show()
            Obiettivi_Punteggio(index) = 0
            'premio bonus
            Call Premio_Bonus(Livello_Diff)
            Me.Enabled = False
        End If
    End Sub

    Public Sub Elabora_Matrice4x4_Down(ByRef Matr2048 As Int32(,))
        Dim Ripeti As Int32 = 0
        Scambio_ok = False
        Punti_Mossa = 0
        While Ripeti < NumericUpDown1.Value

            For c As Int32 = 4 To 2 Step -1
                For r As Int32 = 1 To 4

                    If Matr2048(c, r) = 1 And Matr2048(c - 1, r) > 1 Then
                        Matr2048(c, r) = Matr2048(c - 1, r)
                        Matr2048(c - 1, r) = 1
                        Scambio_ok = True
                    End If

                    If Ripeti = 0 Or Ripeti = 2 Then
                        If Matr2048(c, r) = Matr2048(c - 1, r) And Matr2048(c, r) > 1 Then
                            Matr2048(c, r) *= 2
                            Matr2048(c - 1, r) = 1
                            Punteggio += Matr2048(c, r)
                            Punti_Mossa += Matr2048(c, r)
                            Scambio_ok = True
                            If Audio_On Then My.Computer.Audio.Play(My.Resources.VGOMyMove, AudioPlayMode.Background)
                            Call Verifica_Ultima_Potenza(Matr2048(c, r))
                        End If
                    End If

                    If Matr2048(c, r) = 1 And Matr2048(c - 1, r) > 1 Then
                        Matr2048(c, r) = Matr2048(c - 1, r)
                        Matr2048(c - 1, r) = 1
                        Scambio_ok = True
                    End If
                Next r
            Next c
            Ripeti += 1
        End While

        Ripeti = 1
        While Ripeti = 1
            Ripeti = 0
            For c As Int32 = 4 To 2 Step -1
                For r As Int32 = 1 To 4
                    If Matr2048(c, r) = 1 And Matr2048(c - 1, r) > 1 Then
                        Matr2048(c, r) = Matr2048(c - 1, r)
                        Matr2048(c - 1, r) = 1
                        Ripeti = 1
                        Scambio_ok = True
                    End If
                Next r
            Next c
        End While
    End Sub

    Public Sub Elabora_Matrice4x4_UP(ByRef Matr2048 As Int32(,))
        Dim Ripeti As Int32 = 0
        Scambio_ok = False
        Punti_Mossa = 0
        While Ripeti < NumericUpDown1.Value

            For c As Int32 = 1 To 3
                For r As Int32 = 4 To 1 Step -1

                    If Matr2048(c, r) = 1 And Matr2048(c + 1, r) > 1 Then
                        Matr2048(c, r) = Matr2048(c + 1, r)
                        Matr2048(c + 1, r) = 1
                        Scambio_ok = True
                    End If

                    If Ripeti = 0 Or Ripeti = 2 Then
                        If Matr2048(c, r) = Matr2048(c + 1, r) And Matr2048(c, r) > 1 Then
                            Matr2048(c, r) *= 2
                            Matr2048(c + 1, r) = 1
                            Punteggio += Matr2048(c, r)
                            Punti_Mossa += Matr2048(c, r)
                            Scambio_ok = True
                            If Audio_On Then My.Computer.Audio.Play(My.Resources.VGOMyMove, AudioPlayMode.Background)
                            Call Verifica_Ultima_Potenza(Matr2048(c, r))
                        End If
                    End If

                    If Matr2048(c, r) = 1 And Matr2048(c + 1, r) > 1 Then
                        Matr2048(c, r) = Matr2048(c + 1, r)
                        Matr2048(c + 1, r) = 1
                        Scambio_ok = True
                    End If
                Next r
            Next c
            Ripeti += 1
        End While

        Ripeti = 1
        While Ripeti = 1
            Ripeti = 0
            For c As Int32 = 1 To 3
                For r As Int32 = 4 To 1 Step -1

                    If Matr2048(c, r) = 1 And Matr2048(c + 1, r) > 1 Then
                        Matr2048(c, r) = Matr2048(c + 1, r)
                        Matr2048(c + 1, r) = 1
                        Ripeti = 1
                        Scambio_ok = True
                    End If
                Next r
            Next c
        End While
    End Sub

    Public Sub Elabora_Matrice4x4_Left(ByRef Matr2048 As Int32(,))
        Dim Ripeti As Int32 = 0
        Scambio_ok = False
        Punti_Mossa = 0
        While Ripeti < NumericUpDown1.Value

            For r As Int32 = 1 To 4
                For c As Int32 = 1 To 3

                    If Matr2048(r, c) = 1 And Matr2048(r, c + 1) > 1 Then
                        Matr2048(r, c) = Matr2048(r, c + 1)
                        Matr2048(r, c + 1) = 1
                        Scambio_ok = True
                    End If

                    If Ripeti = 0 Or Ripeti = 2 Then
                        If Matr2048(r, c) = Matr2048(r, c + 1) And Matr2048(r, c) > 1 Then
                            Matr2048(r, c) *= 2
                            Matr2048(r, c + 1) = 1
                            Punteggio += Matr2048(r, c)
                            Punti_Mossa += Matr2048(r, c)
                            Scambio_ok = True
                            If Audio_On Then My.Computer.Audio.Play(My.Resources.VGOMyMove, AudioPlayMode.Background)
                            Call Verifica_Ultima_Potenza(Matr2048(r, c))
                        End If
                    End If

                    If Matr2048(r, c) = 1 And Matr2048(r, c + 1) > 1 Then
                        Matr2048(r, c) = Matr2048(r, c + 1)
                        Matr2048(r, c + 1) = 1
                        Scambio_ok = True
                    End If
                Next c
            Next r
            Ripeti += 1
        End While

        Ripeti = 1
        While Ripeti = 1
            Ripeti = 0
            For r As Int32 = 1 To 4
                For c As Int32 = 1 To 3
                    If Matr2048(r, c) = 1 And Matr2048(r, c + 1) > 1 Then
                        Matr2048(r, c) = Matr2048(r, c + 1)
                        Matr2048(r, c + 1) = 1
                        Ripeti = 1
                        Scambio_ok = True
                    End If
                Next c
            Next r
        End While
    End Sub

    Public Sub Elabora_Matrice4x4_Right(ByRef Matr2048 As Int32(,))
        Dim Ripeti As Int32 = 0
        Scambio_ok = False
        Punti_Mossa = 0
        While Ripeti < NumericUpDown1.Value

            For r As Int32 = 1 To 4
                For c As Int32 = 4 To 2 Step -1
                    If Matr2048(r, c) = 1 And Matr2048(r, c - 1) > 1 Then
                        Matr2048(r, c) = Matr2048(r, c - 1)
                        Matr2048(r, c - 1) = 1
                        Scambio_ok = True
                    End If

                    If Ripeti = 0 Or Ripeti = 2 Then
                        If Matr2048(r, c) = Matr2048(r, c - 1) And Matr2048(r, c) > 1 Then
                            Matr2048(r, c) *= 2
                            Matr2048(r, c - 1) = 1
                            Punteggio += Matr2048(r, c)
                            Punti_Mossa += Matr2048(r, c)
                            Scambio_ok = True
                            If Audio_On Then My.Computer.Audio.Play(My.Resources.VGOMyMove, AudioPlayMode.Background)
                            Call Verifica_Ultima_Potenza(Matr2048(r, c))
                        End If
                    End If

                    If Matr2048(r, c) = 1 And Matr2048(r, c - 1) > 1 Then
                        Matr2048(r, c) = Matr2048(r, c - 1)
                        Matr2048(r, c - 1) = 1
                        Scambio_ok = True
                    End If

                Next c
            Next r
            Ripeti += 1
        End While

        Ripeti = 1
        While Ripeti = 1
            Ripeti = 0
            For r As Int32 = 1 To 4
                For c As Int32 = 4 To 2 Step -1
                    If Matr2048(r, c) = 1 And Matr2048(r, c - 1) > 1 Then
                        Matr2048(r, c) = Matr2048(r, c - 1)
                        Matr2048(r, c - 1) = 1
                        Ripeti = 1
                        Scambio_ok = True
                    End If
                Next c
            Next r
        End While
    End Sub

    Public Sub Inizializza_Matrice2048(ByRef Matr2048 As Int32(,))
        For r As Int32 = 1 To 4
            For c As Int32 = 1 To 4
                Matr2048(r, c) = 1
            Next c
        Next r
    End Sub

    Public Sub Copia_Matrice2048(ByRef Matr2048 As Int32(,), ByRef CopiaMatrice As Int32(,))
        'clona la matrice base
        Array.Copy(Matr2048, CopiaMatrice, 25)
    End Sub

    Public Sub verifica_Mosse(ByRef Matr2048 As Int32(,))
        'verifica che ci siano mosse possibili
        Dim flag As Boolean = False
        For R = 1 To 4
            For C = 1 To 4
                If Matr2048(R, C) = 1 Then
                    flag = True
                End If
            Next C
        Next R

        For R = 1 To 4
            For C = 1 To 3
                If Matr2048(R, C) = Matr2048(R, C + 1) Then
                    flag = True
                End If
            Next C
        Next R

        For c As Int32 = 1 To 3
            For r As Int32 = 4 To 1 Step -1
                If Matr2048(c, r) = Matr2048(c + 1, r) Then
                    flag = True
                End If
            Next r
        Next c

        If flag = False And AutoOn = False Then
            If Audio_On Then Thread.Sleep(100)
            If Audio_On Then Suono1.Play()
            'Lancia l'avviso di gioco finito   'modifica di Ultimo 5-7-2018 ore 23
            Call Game_Over.Show() : Me.Enabled = False
            Exit Sub
        End If

    End Sub

    Public Sub Random_Matrice4x4_2048()
        If Stato_eventi = Stato.Azzerato Then
            Stato_eventi = Stato.Avviato
            Estrai()
            Thread.Sleep(200)
            'Ricorsiva
            Random_Matrice4x4_2048()
        Else
            Estrai()
        End If
    End Sub

    Public Sub Estrai()
        Dim rand As New Random
        Dim R As Int32
        Dim C As Int32
        Do
            R = rand.Next(1, 5)
            C = rand.Next(1, 5)
            If Matrice4x4(R, C) = 1 Then
                Matrice4x4(R, C) = Rand_2_4()
                Indx_Nuovo_Val = R & "-" & C
                ' controllo solo a inizio partita
                If Max_Potenza_Raggiunta < 4 Then Verifica_Ultima_Potenza(Matrice4x4(R, C))
                Exit Do
            End If
        Loop
    End Sub

    Public Function Rand_2_4() As Int32
        Dim rand As New Random
        Dim num As Int32
        Dim opz() As Int32 = opz_Scelta.ToArray
        num = opz(rand.Next(0, opz.Length))
        Return num
    End Function

    Private Sub Controlla_Punteggio()
        'Modificato Carlo 7-7-2018 ore 11 -------------
        If Stato_eventi = Not Stato.Avviato Then Return
        '----------------------------------------------
        Dim new_record As Int32
        new_record = Punteggio - (CInt(My.Settings.Record))
        If new_record > 0 Then
            Giocatore = TextBox_Nome.Text
            My.Settings.Record = Punteggio
            My.Settings.Mosse_Rec = mosse
            My.Settings.Nome = Giocatore
            My.Settings.Max_Valore = Max_Potenza_Raggiunta
            My.Settings.Save()
            If Audio_On Then Thread.Sleep(200)
            If Nuovo_Record = False Then
                Nuovo_Record = True
                If Audio_On Then Suono2.play()
                Label1.ForeColor = Color.Red
            End If
        End If
        Label1.Text = "Punteggio Record: " & My.Settings.Record
        Label2.Text = "Mosse: " & My.Settings.Mosse_Rec
        Label3.Text = "Record di: " & My.Settings.Nome
        Label4.Text = "Max_Val: " & My.Settings.Max_Valore
        Me.TSLabel_Stato.Text = "Stato: Punteggio " & Punteggio & "   Mosse " & mosse
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        ' aggiunto Carlo, modificato Ultimo
        If Win Then
            Exit Sub
        End If
        If Stato_eventi = Stato.Azzerato Then
            lblInfo.Text = DateTime.Now.ToString
            Partenza = DateTime.Now
        ElseIf Stato_eventi = Stato.Avviato Then
            ' modificato Carlo 12-7-2018 aggiunto breaktime
            Tempo = DateTime.FromOADate(DateTime.Now.ToOADate - Partenza.ToOADate - BreakTime)
            lblInfo.Text = "Tempo:        " & Tempo
        End If
    End Sub

#End Region

#Region "Funzioni e Procedure per il disegno e visualizzazione delle Immagini dei Pbx "

    'Disegna lo schema 4 x 4 del gioco
    Public Sub CreaSchema4X4Classic2048()
        Panel1.Controls.Clear()
        ReDim Mat4x4Pict_2040(16)
        Dim xP, yP, nCel, size_c As Integer

        yP = 12
        nCel = 0
        size_c = 84

        For i As Int32 = 1 To 4 Step +1
            xP = 13
            For j As Int32 = 1 To 4 Step +1
                nCel += 1
                Mat4x4Pict_2040(nCel) = New PictureBox
                Mat4x4Pict_2040(nCel).AutoSize = False
                Mat4x4Pict_2040(nCel).Font = New System.Drawing.Font("Arial", 12, FontStyle.Bold)
                Mat4x4Pict_2040(nCel).Size = New System.Drawing.Size(size_c, size_c)
                Mat4x4Pict_2040(nCel).Location = New System.Drawing.Point(xP, yP)
                Mat4x4Pict_2040(nCel).BackColor = Scelta_Colori(TipoGrafica)
                Mat4x4Pict_2040(nCel).ForeColor = Color.Maroon
                Mat4x4Pict_2040(nCel).Name = "Cella_" & i.ToString & "-" & j.ToString
                Mat4x4Pict_2040(nCel).Text = j.ToString
                Mat4x4Pict_2040(nCel).Tag = (i).ToString & "-" & (j).ToString
                Mat4x4Pict_2040(nCel).BackgroundImageLayout = ImageLayout.Center
                Panel1.Controls.Add(Mat4x4Pict_2040(nCel))
                xP = xP + (size_c + 2)
            Next j
            yP = yP + (size_c + 2)
        Next i
    End Sub

    Private Sub cambia_colore_P(ByVal sender As Object)

        Dim nome_P As String = sender.tag

        Me.But_L.BackColor = Color.White
        Me.But_R.BackColor = Color.White
        Me.But_UP.BackColor = Color.White
        Me.But_Down.BackColor = Color.White

        Select Case nome_P
            Case Is = "L"
                Me.But_L.BackColor = Color.DarkOliveGreen
            Case Is = "R"
                Me.But_R.BackColor = Color.DarkOliveGreen
            Case Is = "U"
                Me.But_UP.BackColor = Color.DarkOliveGreen
            Case Is = "D"
                Me.But_Down.BackColor = Color.DarkOliveGreen
        End Select
        If Stato_eventi = Stato.Avviato Then
            mosse += 1
            Me.TSLabel_Stato.Text = "Stato: Punteggio " & Punteggio & "   Mosse " & mosse
        End If
        If Not Timer1.Enabled Then
            Timer1.Enabled = True
        End If
    End Sub

    Public Sub Animazione_Pbx(ByRef Pbx As PictureBox)
        'Movimento animato di una PictureBox.
        If Stato_eventi = Stato.Avviato Then InMovimento = True  'evita errore
        If Pbx Is Nothing Then Return
        Me.Refresh()
        If Me.Animazione2ToolStrip.Checked = True Then
            Pbx.BringToFront()
            Dim Location_Pbx As Point
            Dim vn1 As Int32 = 3
            Dim vn2 As Int32 = 1

            For j As Int32 = 1 To 5
                Pbx.Width -= vn1
                Pbx.Height -= vn1
                Thread.Sleep(1)
                Location_Pbx = New Point(Pbx.Left + vn2, Pbx.Top + vn2)
                Pbx.Location = Location_Pbx
            Next j

            For i As Int32 = 1 To 5
                Pbx.Width += vn1
                Pbx.Height += vn1
                Thread.Sleep(50)
                Location_Pbx = New Point(Pbx.Left - vn2, Pbx.Top - vn2)
                Pbx.Location = Location_Pbx
                Pbx.Refresh()
            Next i
        ElseIf Me.Animazione1ToolStrip.Checked = True Then
            Dim Immagine As Bitmap = Pbx.Image
            Pbx.Image = Nothing
            Pbx.Refresh()
            For i = -84 To 0
                Using PbxGraphics As Graphics = Pbx.CreateGraphics()
                    PbxGraphics.DrawImage(Immagine, 0, i, 84, 84)
                End Using
                Thread.Sleep(2)
            Next i
            Pbx.Image = Immagine
            Pbx.Refresh()
        ElseIf Me.Animazione3ToolStrip.Checked = True Then
            Dim Immagine As Bitmap = Pbx.Image
            Pbx.Image = Nothing
            Pbx.Refresh()
            For i = 0 To 84
                Using PbxGraphics As Graphics = Pbx.CreateGraphics()
                    PbxGraphics.DrawImage(Immagine, 42 - i \ 2, 42 - i \ 2, i, i)
                End Using
                Thread.Sleep(2)
            Next i
            Pbx.Image = Immagine
            Pbx.Refresh()
        End If
    End Sub

    Public Sub Visualizza_Immagine_Celle2048(ByRef Matr2048 As Int32(,))
        'indice della cella nuovo valore random
        Dim invr As Int32

        For i As Int32 = 1 To 16
            Dim Tag_Cella As String = ""
            Tag_Cella = Mat4x4Pict_2040(i).Tag
            For r As Int32 = 1 To 4
                For c As Int32 = 1 To 4
                    Dim index_M As String = r & "-" & c

                    If index_M = Tag_Cella Then
                        '** Inserisce le rispettive immagini **
                        If Matr2048(r, c) = 1 Then
                            Mat4x4Pict_2040(i).Image = Nothing
                        Else
                            Mat4x4Pict_2040(i).Image = Me.ImageList1.Images(CInt(Math.Log(Matr2048(r, c), 2)) - 1)
                            If index_M = Indx_Nuovo_Val Then
                                invr = i
                            End If
                        End If
                        '************************
                    End If
                Next c

            Next r

        Next i

        '** Inserimento immagine corrispondente **
        If Max_Potenza_Raggiunta > 1 Then
            Me.PictureBox1.BackgroundImage = Me.ImageList1.Images(CInt(Math.Log(Max_Potenza_Raggiunta, 2)) - 1)
        End If
        '************************

        'Avvio la procedura di animazione
        If Animazione_On Then Call Animazione_Pbx(Mat4x4Pict_2040(invr))

        Me.Refresh()
        'verifichiamo il punteggio
        If Stato_eventi = Stato.Avviato Then
            Call Controlla_Punteggio()
            'gestire salvataggio on off, aggiunto indice della casella animata
            If Registra_Partita Then Call Salva_Sequenza(Indx_Nuovo_Val)
        End If

    End Sub

    Private Sub Crea_Simboli(TipoSimboli As Short)
        ' Carlo aggiunta grafica GDI
        Dim imgbmp As Bitmap = Nothing
        ImageList1.Images.Clear() ' svuoto ImageList1
        If TipoSimboli = 1 Then ' Grafica 1
            Dim Fondo As New SolidBrush(Color.Transparent)
            Dim Colore_Font As New List(Of Brush)
            Colore_Font.Add(Brushes.Black) '2
            Colore_Font.Add(Brushes.Black) '4
            Colore_Font.Add(Brushes.White) '8
            Colore_Font.Add(Brushes.DarkRed) '16
            Colore_Font.Add(Brushes.Blue) '32
            Colore_Font.Add(Brushes.Yellow) '64
            Colore_Font.Add(Brushes.Blue) '128
            Colore_Font.Add(Brushes.Black) '256
            Colore_Font.Add(Brushes.White) '512
            Colore_Font.Add(Brushes.LimeGreen) '1024
            Colore_Font.Add(Brushes.White) '2048
            Colore_Font.Add(Brushes.DarkRed) '4096
            Colore_Font.Add(Brushes.Red) '8192
            Colore_Font.Add(Brushes.Yellow) '16384
            Colore_Font.Add(Brushes.White) '32768
            Colore_Font.Add(Brushes.DarkGoldenrod) '65536
            'Carico una matrice con il valore da scrivere e il rispettivo colore di fondo in RGB
            Dim ColoreFondo(,) As Integer = {{2, 14, 209, 69}, {4, 255, 127, 39}, {8, 185, 122, 86}, {16, 0, 168, 243}, {32, 225, 184, 44},
                                          {64, 0, 53, 243}, {128, 255, 242, 0}, {256, 196, 255, 14}, {512, 160, 13, 234},
                                          {1024, 155, 112, 77}, {2048, 230, 17, 81}, {4096, 181, 181, 223}, {8192, 91, 92, 67}, {16384, 60, 60, 40}, {32768, 40, 40, 10}, {65536, 0, 0, 0}}

            For i = 0 To 15 ' ciclo per creare 16 tessere grafiche
                imgbmp = New Bitmap(84, 84) ' creo una bitmap in ram 84x84 pixel
                Using g As Graphics = Graphics.FromImage(imgbmp) ' istanzio l'oggetto g che disegnerà su imgbmp
                    g.TextRenderingHint = Drawing.Text.TextRenderingHint.AntiAliasGridFit ' setto alta qualità di disegno per i testi
                    Dim Testo As String = ColoreFondo(i, 0).ToString ' testo da scrivere
                    Fondo = New SolidBrush(Color.FromArgb(255, ColoreFondo(i, 1), ColoreFondo(i, 2), ColoreFondo(i, 3))) ' colore di fondo del numero corrente
                    g.Clear(Color.Snow) ' cancello la casella con il colore bianconeve
                    g.FillEllipse(Fondo, -14, -14, 111, 111) ' disegno un'ellisse più grande della bitmap per creare l'effetto stondato

                    If i < 2 Then
                        Using Carattere As Font = New Font("Arial", 26, FontStyle.Bold)
                            g.DrawString(Testo, Carattere, Colore_Font(i), New PointF(26, 22)) ' 2, 4
                        End Using
                    ElseIf i = 2 Then
                        Using Carattere As Font = New Font("Arial", 26, FontStyle.Regular)
                            g.DrawString(Testo, Carattere, Colore_Font(i), New PointF(26, 22)) ' 8
                        End Using
                    ElseIf i > 2 And i < 6 Then
                        Using Carattere As Font = New Font("Arial", 26, FontStyle.Regular)
                            g.DrawString(Testo, Carattere, Colore_Font(i), New PointF(18, 22)) ' 16, 32, 64
                        End Using
                    ElseIf i > 5 And i < 9 Then
                        Using Carattere As Font = New Font("Arial", 26, FontStyle.Regular)
                            g.DrawString(Testo, Carattere, Colore_Font(i), New PointF(8, 22)) ' 128, 256, 512
                        End Using
                    ElseIf i > 8 And i < 13 Then
                        Using Carattere As Font = New Font("Arial", 22, FontStyle.Regular)
                            g.DrawString(Testo, Carattere, Colore_Font(i), New PointF(5, 26)) ' 1024, 2048, 4096, 8192
                        End Using
                    ElseIf i > 12 Then
                        Using Carattere As Font = New Font("Arial", 19, FontStyle.Regular)
                            g.DrawString(Testo, Carattere, Colore_Font(i), New PointF(3, 28)) ' 16384, 32768, 65536
                        End Using
                    End If
                End Using
                ImageList1.Images.Add(imgbmp) ' aggiungo a ImageList1 la BitMap appena disegnata
            Next
            Panel1.BackColor = Color.Snow ' colore di fondo del Panel1, contenitore di tutte le caselle
            PictureBox1.BackColor = Color.Silver ' colore di fondo della PictureBox1, massima potenza raggiunta
            Call ToolStrip_Checked(TipoGrafica) ' carica i colori di fondo di Mat4x4Pict_2040 in accordo alla grafica scelta, si vede quando non ci sono i numeri
        ElseIf TipoSimboli = 2 Then ' Grafica 2
            Dim Fondo As New SolidBrush(Color.Transparent)
            ' Carico una matrice con il valore da scrivere e il rispettivo colore di fondo in RGB
            Dim ColoreFondo(,) As Integer = {{2, 245, 245, 245}, {4, 245, 245, 220}, {8, 242, 177, 121}, {16, 245, 149, 99}, {32, 245, 124, 97},
                                          {64, 255, 10, 10}, {128, 250, 220, 90}, {256, 240, 225, 80}, {512, 235, 200, 0},
                                          {1024, 230, 190, 0}, {2048, 220, 160, 0}, {4096, 0, 0, 0}, {8192, 0, 0, 0}, {16384, 0, 0, 0}, {32768, 0, 0, 0}, {65536, 0, 0, 0}}
            For i = 0 To 15 ' ciclo per creare 14 tessere grafiche
                imgbmp = New Bitmap(84, 84) ' creo una bitmap in ram 84x84 pixel
                Using g As Graphics = Graphics.FromImage(imgbmp) ' istanzio l'oggetto g che disegnerà su imgbmp
                    g.TextRenderingHint = Drawing.Text.TextRenderingHint.AntiAliasGridFit ' setto alta qualità di disegno per i testi
                    Dim Testo As String = ColoreFondo(i, 0).ToString ' testo da scrivere
                    Fondo = New SolidBrush(Color.FromArgb(255, ColoreFondo(i, 1), ColoreFondo(i, 2), ColoreFondo(i, 3))) ' colore di fondo del numero corrente
                    g.FillRectangle(Fondo, 4, 4, 76, 76) ' disegno un rettangolo più piccolo della bitmap per creare l'effetto tessera
                    If i < 3 Then
                        Using Carattere As Font = New Font("Arial", 32, FontStyle.Bold)
                            g.DrawString(Testo, Carattere, Brushes.DarkSlateGray, New PointF(24, 20)) ' 2, 4 e 8
                        End Using
                    ElseIf i < 6 And i > 2 Then
                        Using Carattere As Font = New Font("Arial", 32, FontStyle.Bold)
                            g.DrawString(Testo, Carattere, Brushes.White, New PointF(12, 20)) ' 16, 32, e 64
                        End Using
                    ElseIf i < 9 And i > 5 Then
                        Using Carattere As Font = New Font("Arial", 28, FontStyle.Bold)
                            g.DrawString(Testo, Carattere, Brushes.White, New PointF(6, 22)) ' 128, 256 e 512
                        End Using
                    ElseIf i < 13 And i > 8 Then
                        Using Carattere As Font = New Font("Arial", 22, FontStyle.Bold)
                            g.DrawString(Testo, Carattere, Brushes.White, New PointF(5, 26)) ' 1024, 2048, 4096 e 8182
                        End Using
                    ElseIf i > 12 Then
                        Using Carattere As Font = New Font("Arial", 18, FontStyle.Bold)
                            g.DrawString(Testo, Carattere, Brushes.White, New PointF(5, 28)) ' 16384, 32768, 65536
                        End Using
                    End If
                End Using
                ImageList1.Images.Add(imgbmp) ' aggiungo a ImageList1 la BitMap appena disegnata
            Next
            Panel1.BackColor = Color.Gray ' colore di fondo del Panel1, contenitore di tutte le caselle
            PictureBox1.BackColor = Color.Gray ' colore di fondo della PictureBox1, massima potenza raggiunta
            Call ToolStrip_Checked(TipoGrafica) ' carica i colori di fondo di Mat4x4Pict_2040 in accordo alla grafica scelta, si vede quando non ci sono i numeri
        ElseIf TipoSimboli = 3 Then ' Grafica 3
            Dim Fondo As New SolidBrush(Color.FromArgb(255, 220, 220, 220))
            Dim Penna As New SolidBrush(Color.FromArgb(255, 40, 40, 40))
            Dim Testo As String
            For i = 0 To 15
                imgbmp = New Bitmap(84, 84)
                Using g As Graphics = Graphics.FromImage(imgbmp)
                    g.TextRenderingHint = Drawing.Text.TextRenderingHint.AntiAliasGridFit
                    g.SmoothingMode = SmoothingMode.AntiAlias
                    Testo = 2 ^ (i + 1).ToString
                    Penna = New SolidBrush(Color.FromArgb(255, 10 * i, i * 10, 17 * i))
                    g.FillRectangle(Fondo, 0, 0, 84, 84)
                    Call Poligono_Regolare(g, Penna, 28 - i, i + 3, 42, 41, 0, True)
                    If i < 13 And i > 8 Then
                        Using Carattere As Font = New Font("Arial", 22, FontStyle.Bold)
                            g.DrawString(2 ^ (i + 1).ToString, Carattere, Brushes.White, New PointF(5, 26))
                        End Using
                    ElseIf i > 12 Then
                        Using Carattere As Font = New Font("Arial", 19, FontStyle.Bold)
                            g.DrawString(2 ^ (i + 1).ToString, Carattere, Brushes.Black, New PointF(3, 28))
                        End Using
                    End If
                End Using
                ImageList1.Images.Add(imgbmp)
            Next
            Panel1.BackColor = Color.IndianRed
            PictureBox1.BackColor = Color.DarkKhaki
            Call ToolStrip_Checked(TipoGrafica)
        ElseIf TipoSimboli = 4 Then
            Dim Fondo As New SolidBrush(Color.Blue)
            Dim Penna As New SolidBrush(Color.Yellow)
            For i = 0 To 15
                imgbmp = New Bitmap(84, 84)
                Using g As Graphics = Graphics.FromImage(imgbmp)
                    g.FillRectangle(Fondo, 0, 0, 84, 84)
                    g.FillRectangle(Penna, 0, 75 - i * 5, 84, 84)
                End Using
                ImageList1.Images.Add(imgbmp)
            Next
            Panel1.BackColor = Color.Coral
            PictureBox1.BackColor = Color.Brown
            Call ToolStrip_Checked(TipoGrafica)
        ElseIf TipoSimboli = 5 Then
            For i = 0 To 15
                ImageList1.Images.Add(ImageList2.Images(i))
            Next
            Panel1.BackColor = Color.Brown
            PictureBox1.BackColor = Color.Brown
            Call ToolStrip_Checked(TipoGrafica)
        ElseIf TipoSimboli = 6 Then
            For i = 0 To 15
                ImageList1.Images.Add(ImageList3.Images(i))
            Next
            Panel1.BackColor = Color.DarkGreen
            PictureBox1.BackColor = Color.DarkGreen
            Call ToolStrip_Checked(TipoGrafica)
        ElseIf TipoSimboli = 7 Then
            Dim Roma() As String = {"    I", "   II", "  III", "  IV", "   V", "   VI", "  VII", " VIII", "  IX", "   X", "  XI", "  XII", " XIII", " XIV", "  XV", " XVI"}
            For i = 0 To 15
                imgbmp = New Bitmap(84, 84) ' creo una bitmap
                Using g As Graphics = Graphics.FromImage(imgbmp) ' g agisce su imgbmp
                    g.TextRenderingHint = Drawing.Text.TextRenderingHint.AntiAliasGridFit
                    g.FillRectangle(Brushes.Navy, 0, 0, 84, 84)
                    Using Carattere As Font = New Font("Georgia", 22, FontStyle.Regular)
                        g.DrawString(Roma(i), Carattere, Brushes.Red, New PointF(5, 26))
                    End Using
                End Using
                ImageList1.Images.Add(imgbmp)
            Next
            Panel1.BackColor = Color.Tomato
            PictureBox1.BackColor = Color.Navy
            Call ToolStrip_Checked(TipoGrafica)
        ElseIf TipoSimboli = 8 Then
            Dim Lettere() As String = {"   A", "   B", "   C", "   D", "   E", "   F", "   G", "   H", "   I", "   J", "   K", "   L", "   M", "   N", "   O", "   P"}
            For i = 0 To 15
                imgbmp = New Bitmap(84, 84) ' creo una bitmap
                Using g As Graphics = Graphics.FromImage(imgbmp) ' g agisce su imgbmp
                    g.TextRenderingHint = Drawing.Text.TextRenderingHint.AntiAliasGridFit
                    g.FillRectangle(Brushes.Navy, 0, 0, 84, 84)
                    Using Carattere As Font = New Font("Georgia", 32, FontStyle.Regular)
                        g.DrawString(Lettere(i), Carattere, Brushes.Red, New PointF(-10, 16))
                    End Using
                End Using
                ImageList1.Images.Add(imgbmp)
            Next
            Panel1.BackColor = Color.Tomato
            PictureBox1.BackColor = Color.Navy
            Call ToolStrip_Checked(TipoGrafica)
        End If

    End Sub

    Public Sub ToolStrip_Checked(ByRef TS As Short)

        Me.ImmaginiSet1ToolStrip.Checked = False
        Me.ImmaginiSet2ToolStrip.Checked = False
        Me.ImmaginiSet3ToolStrip.Checked = False
        Me.ImmaginiSet4ToolStrip.Checked = False
        Me.ImmaginiSet5ToolStrip.Checked = False
        Me.ImmaginiSet6ToolStrip.Checked = False
        Me.ImmaginiSet7ToolStrip.Checked = False
        Me.ImmaginiSet8ToolStrip.Checked = False

        Select Case TS

            Case = 1
                Me.ImmaginiSet1ToolStrip.Checked = True
            Case = 2
                Me.ImmaginiSet2ToolStrip.Checked = True
            Case = 3
                Me.ImmaginiSet3ToolStrip.Checked = True
            Case = 4
                Me.ImmaginiSet4ToolStrip.Checked = True
            Case = 5
                Me.ImmaginiSet5ToolStrip.Checked = True
            Case = 6
                Me.ImmaginiSet6ToolStrip.Checked = True
            Case = 7
                Me.ImmaginiSet7ToolStrip.Checked = True
            Case = 8
                Me.ImmaginiSet8ToolStrip.Checked = True
        End Select

    End Sub

    Private Sub VisualizzaTest_Immagini()
        'Resetta Set immagini
        For j As Int32 = 0 To 15
            Mat4x4Pict_2040(j + 1).Image = Nothing
        Next
        'mostra Set immagini nuove
        For i As Int32 = 0 To 15
            Mat4x4Pict_2040(i + 1).Image = ImageList1.Images(i)
        Next i
    End Sub

    Private Sub printmatrice(ByRef Matr2048 As Int32(,))
        ' mostra lo stato della matrice solo per debug
        For R = 1 To 4
            Debug.Print(Matr2048(R, 1).ToString & Matr2048(R, 2).ToString & Matr2048(R, 3).ToString & Matr2048(R, 4).ToString)
        Next
    End Sub

    Private Sub Poligono_Regolare(ByVal gR As Graphics, ByVal Solido As Brush, ByVal MisuraLato As Single, ByVal NumeroLati As Single, ByVal XCentro As Single, ByVal YCentro As Single, ByVal GradiRotazione As Single, ByVal Pieno As Boolean)

        'Trasforma i GradiRotazione in Radianti
        Dim RadiantiRotazione As Single = GradiRotazione * Math.PI / 180

        'Archi del cerchio(IN RADIANTI)entro il quale s'immagina inscritto il poligono,
        'occupati dal punto ZERO (minima coordinata Y dell'area di disegno)all'estremo
        'finale di ogni lato. Non serve l'estremo dell'ultimo lato, perchè è uguale al
        'punto ZERO.
        Dim ARCHI As Single = 360 * Math.PI / 180 / NumeroLati

        'Dichiara una Matrice con numero elementi pari a NumLati per contenere
        'l'arco complessivo(in RADIANTI)occupato dal punto più alto del cerchio
        '(zero radianti)ai punti successivi (estremi dei lati).
        Dim aArc(NumeroLati) As Single

        'Carica la matrice con gli archi complessivi (in radianti) dei suddetti punti
        For i As Short = 0 To NumeroLati
            aArc(i) = ARCHI * i
        Next

        '  1)Calcolo del Numero Fisso (serve solo il numero dei lati: NumLati)
        Dim nFisso As Single = 0.5 / Math.Tan(Math.PI / NumeroLati)

        '  2)Calcolo Apotema (servono Numero Fisso e Misura del Lato)
        Dim Apotema As Single = nFisso * MisuraLato

        '  3)Calcolo Raggio del cerchio in cui il poligono si immagina iscritto (è
        '  anche il raggio del poligono)
        Dim Raggio As Single = Math.Sqrt(Apotema ^ 2 + (MisuraLato / 2) ^ 2)

        'Dichiara una Matrice con numero elementi pari a NumLati per contenere le
        'coordinate X di ogni punto
        Dim XPunto(NumeroLati) As Single

        'Dichiara una Matrice con numero elementi pari a NumLati per contenere le
        'coordinate Y di ogni punto
        Dim YPunto(NumeroLati) As Single

        'Carica le 2 matrici suddette con le relative coordinate X ed Y
        For k As Short = 0 To NumeroLati - 1
            XPunto(k) = XCentro + Raggio * Math.Sin(aArc(k) + RadiantiRotazione)
            YPunto(k) = YCentro - Raggio * Math.Cos(aArc(k) + RadiantiRotazione)
        Next

        'Definisce un'istanza della Classe GraphicsPath, atta a contenere un
        ' "insieme" di disegni
        Dim Percorso As New GraphicsPath

        ' Crea un Percorso con tutte le linee CONSECUTIVE che costituiscono
        ' i Lati di un poligono tranne l'ultima, che è aggiunta poi tramite
        ' "CloseFigure()"
        For i As Short = 0 To NumeroLati - 2
            Percorso.AddLine(XPunto(i), YPunto(i), XPunto(i + 1), YPunto(i + 1))
        Next (i)

        'La seg. istruzione chiude il poligono, creando automaticamente l'ultimo lato
        Percorso.CloseFigure()

        If Pieno Then
            'DISEGNA IL POLIGONO REGOLARE PIENO(che corrisponde al path appena costruito)
            'Solido deve essere di tipo Brush
            gR.FillPath(Solido, Percorso)
        Else
            'DISEGNA IL POLIGONO REGOLARE VUOTO(che corrisponde al path appena costruito)
            Dim Penna As New Pen(Solido) ' conversione da Brush a Pen
            'Penna deve essere di tipo Pen
            gR.DrawPath(Penna, Percorso)
        End If

    End Sub

#End Region

#Region "Funzioni e procedure per i replay delle mosse"

    Private Sub Salva_Sequenza(ByVal cAni As String)
        ' modificato Carlo 7-7-2018 ore 11 --------------------------------------------------------------------------------
        'recupera data e ora della variabile Partenza
        Dim Memo_stringa_data As String = Partenza.ToString
        Dim SequenzeInFile As System.IO.StreamWriter
        Memo_stringa_data = Memo_stringa_data.Replace(" ", "_").Trim
        Memo_stringa_data = Memo_stringa_data.Replace(":", "").Trim
        Memo_stringa_data = Memo_stringa_data.Replace("/"c, "")
        Memo_stringa_data = Memo_stringa_data.Trim

        ' preparo la riga da srivere
        Dim Riga As String = ""
        For r = 1 To 4
            For c = 1 To 4
                Riga = Riga & Matrice4x4(r, c) & ";"
            Next
        Next

        ' file aperto e chiuso, siamo in un ambiente multitask, non sappiamo cosa fa un utente
        SequenzeInFile = My.Computer.FileSystem.OpenTextFileWriter(Application.StartupPath & "\Risorse\Replay\" & Giocatore & "_" & Memo_stringa_data & ".txt", True)
        SequenzeInFile.WriteLine(Riga & DateTime.Now.ToString & ";" & cAni & ";" & Punteggio) ' aggiunto indice della casella animata e punteggio
        SequenzeInFile.Close() ' chiudo il file
        SequenzeInFile.Dispose() ' rilascio la risorsa
        '------------------------------------------------------------------------------------------------------------------
    End Sub

    Private Sub ButtRivedi_Click(sender As Object, e As EventArgs) Handles ButtRivedi.Click
        ' aggiunto Carlo 7-7-2018 ore 11
        If Stato_eventi = Stato.Avviato Then Return
        If ButtRivedi.Text = "rivedi" Then
            AzzeraToolStripMenuItem_Click(0, e)
            Me.ButtonAvvia.Enabled = False
            Timer1.Enabled = False
            mosse = 0
            Punteggio = 0

            Dim NomePartita As String
            OpenFileDialog1.Title = "Carica la partita salvata"
            OpenFileDialog1.FileName = ""
            OpenFileDialog1.InitialDirectory = Application.StartupPath & "\Risorse\Replay"
            OpenFileDialog1.Filter = "Schema.txt|*.txt"
            OpenFileDialog1.ShowDialog()
            NomePartita = OpenFileDialog1.FileName
            If NomePartita = "" Then Me.ButtonAvvia.Enabled = True : Exit Sub
            If Livello_Diff = Difficoltà.Facile Then Me.ButtRivedi.Text = "gioca"
            Me.ButtonAvvia.Text = ""
            Animazione_On = False
            Stato_eventi = Stato.Rivedi
            Me.ButtonAvvia.Enabled = False
            Me.But_UP.Visible = False
            Me.But_Down.Visible = False
            GroupBox1.Enabled = False
            '*** non ho voluto usare string.right (Visual Basic) ***
            '******    correggere con soluzione + elegante     *****
            Dim LunghezzaPercorso As Short = NomePartita.Length
            If LunghezzaPercorso > 65 Then LunghezzaPercorso = 65
            ' Visualizzo 65 caratteri a destra
            Me.Text = ".... " & NomePartita.Substring(NomePartita.Length - LunghezzaPercorso)
            Dim objReader As New StreamReader(NomePartita)
            RigaLetta = objReader.ReadToEnd().Split(Environment.NewLine).ToArray ' Leggo tutte le righe del file
            objReader.Close()
            Dim Sequenza() As String = RigaLetta(mosse).Split(";").ToArray
            If RigaLetta(RigaLetta.Length - 1) <> Convert.ToChar(10) Or (Sequenza.Length <> 19 And Sequenza.Length <> 17) Then
                Me.Text = "2048 the Game ... errore nel file"
                Me.TextBox_Nome.Text = "errore nel file"
                Me.ButtRivedi.Text = "errore"
                Me.ButtonAvvia.Text = "errore"
                Me.ButtRegistra.Text = "errore"
                Me.Refresh()
                Suono1.Play()
                Thread.Sleep(2000)
                AzzeraToolStripMenuItem_Click(0, New System.EventArgs())
                Return
            End If

            Me.HScrollBar1.Maximum = RigaLetta.Length - 2
            Me.HScrollBar1.Minimum = 0
            Me.HScrollBar1.Value = 0
            Me.HScrollBar1.Visible = True
            For i = 0 To 15
                Dim r As Short = Math.Ceiling(i \ 4)
                Dim c As Short = i Mod 4
                Matrice4x4(r + 1, c + 1) = Sequenza(i)
                If Sequenza(i) > Max_Potenza_Raggiunta Then Max_Potenza_Raggiunta = Sequenza(i)
            Next
            Visualizza_Immagine_Celle2048(Matrice4x4)
            Me.lblInfo.Text = Sequenza(16) ' orario della mossa
            TSLabel_Stato.Text = "Stato: Punteggio " & Punteggio & "   Mosse " & mosse
        Else
            '*********** evento per tornare alla giocabilità ****************

            Timer1.Enabled = True
            Stato_eventi = Stato.Avviato
            InMovimento = False
            Me.ButtRivedi.Text = "rivedi"
            Me.ButtonAvvia.Enabled = True
            Me.ButtonAvvia.Text = "in play "
            HScrollBar1.Visible = False
            Array.Clear(RigaLetta, 0, RigaLetta.Length)
            Animazione_On = AnimazioneOnoffToolStrip.Checked
            Me.But_UP.Visible = True
            Me.But_Down.Visible = True
            Me.Text = "2048 The Game v." & My.Application.Info.Version.ToString
        End If

    End Sub

    Private Sub HScrollBar1_Scroll(sender As Object, e As ScrollEventArgs) Handles HScrollBar1.Scroll
        ' aggiunto Carlo 7-7-2018 ore 11
        Static mossePrev As Integer

        mosse = HScrollBar1.Value
        If mosse = mossePrev Then Return ' la scroll bar restituisce più volte lo stesso valore, inutile rivisualizzare
        Scorre_Matrice(mosse, False) ' da scroll bar, animazione sempre off
        mossePrev = mosse
    End Sub

    Private Sub Scorre_Matrice(ByVal pos As Integer, ByVal Ani As Boolean)
        ' aggiunto Carlo 7-7-2018 ore 11
        Dim MaxPotenza As Integer

        If RigaLetta Is Nothing Then Return
        mosse = pos
        HScrollBar1.Value = mosse ' aggiorno la posizione della scroll bar

        Dim Sequenza() As String = RigaLetta(mosse).Split(";").ToArray ' da stringa a vettore
        For i = 0 To 15
            Matrice4x4(Math.Ceiling(i \ 4) + 1, i Mod 4 + 1) = Sequenza(i) ' mosse salvate
            If Sequenza(i) > MaxPotenza Then MaxPotenza = Sequenza(i) ' controllo massima potenza raggiunta
        Next
        Max_Potenza_Raggiunta = MaxPotenza
        If Sequenza.Length <> 17 Then ' compatibilità con vecchia registrazione evita l'errore, eliminare quando le vecchie registrazioni senza punteggio, saranno sostituite
            Indx_Nuovo_Val = Sequenza(17) ' indice della casella animata ripassato a Visualizza_Immagine_Celle2048(), attraverso Indx_Nuovo_Val
            Punteggio = Sequenza(18) ' punteggio salvato della mossa
        End If
        Animazione_On = Ani
        Visualizza_Immagine_Celle2048(Matrice4x4)
        lblInfo.Text = Sequenza(16) ' orario salvato della mossa
        TSLabel_Stato.Text = "Stato: Punteggio " & Punteggio & "   Mosse " & mosse
    End Sub

    Private Sub RegistraPartitaOnOffToolStrip_Click(sender As Object, e As EventArgs) Handles RegistraPartitaOnOffToolStrip.Click
        ' Modificato Carlo 7-7-2018 ore 11
        Registra_Partita = Not Registra_Partita
        RegistraPartitaOnOffToolStrip.Checked = Registra_Partita
        ButtRegistra.Text = Registra_Partita
        If Registra_Partita Then
            ButtRegistra.BackgroundImage = My.Resources.buttRegistra
        Else
            ButtRegistra.BackgroundImage = My.Resources.buttRegistraBW
        End If
    End Sub

    ' aggiunto Carlo 8-7-2018 ore 11
    Public Sub CaricaSospesa()
        For i = 0 To 15
            Matrice4x4(Math.Ceiling(i \ 4) + 1, i Mod 4 + 1) = RigaLettaInSospensione(i + 1) ' mosse salvate
        Next
        Call Copia_Matrice2048(Matrice4x4, Matrice_Back1) ' solo per evitare errore se si preme "Z", non funzionale
        'Progressione parametri salvati
        'Giocatore & ";" & Form1.Punteggio & ";" & Form1.mosse & ";" & Form1.Animazione_On & ";" & Form1.Audio_On & ";" & _
        'Form1.Registra_Partita & ";" & Form1.ButtAutocompletamento.Text & ";" & Form1.Butt_1PassoBack.Text & ";" & _
        'Form1.Max_Potenza_Raggiunta.ToString & ";" & Form1.TipoGrafica.ToString & ";" & Form1.Tempo.ToOADate() & ";" & Livello_Diff
        Giocatore = RigaLettaInSospensione(17)
        Punteggio = RigaLettaInSospensione(18)
        mosse = RigaLettaInSospensione(19)
        Animazione_On = Not Convert.ToBoolean(RigaLettaInSospensione(20)) : Call AnimazioneOnoffToolStrip_Click(0, New System.EventArgs())
        Audio_On = Not Convert.ToBoolean(RigaLettaInSospensione(21)) : Call AudioOnOffToolStrip_Click(0, New System.EventArgs())
        Registra_Partita = Not Convert.ToBoolean(RigaLettaInSospensione(22)) : Call RegistraPartitaOnOffToolStrip_Click(0, New System.EventArgs())
        NumericUpDown1.Value = Convert.ToInt32(RigaLettaInSospensione(23))
        Butt_1PassoBack.Text = RigaLettaInSospensione(24) : Back_Bonus = Convert.ToInt32(RigaLettaInSospensione(24))
        Max_Potenza_Raggiunta = Convert.ToInt32(RigaLettaInSospensione(25))
        TipoGrafica = Convert.ToInt32(RigaLettaInSospensione(26)) : Call ImmSet_Click(TipoGrafica)
        Dim TempoPassato As Double = DateTime.Now.ToOADate - RigaLettaInSospensione(27) ' sottraggo il tempo trascorso nella precedente partita
        Partenza = DateTime.FromOADate(TempoPassato) ' inserisco il valore in Partenza

        Livello_Diff = RigaLettaInSospensione(28)
        Me.FacileToolStrip.Checked = False
        Me.MediaToolStrip.Checked = False
        Me.DifficileToolStrip.Checked = False
        Me.MoltoDifficileToolStrip.Checked = False

        GroupBox1.Enabled = False

        Select Case Livello_Diff
            Case Is = Difficoltà.Facile
                Me.FacileToolStrip.Checked = True
                RadioBF.Checked = True
                Lbl_Diff.Text = "Diff: Facile"
            Case Is = Difficoltà.Media
                Me.MediaToolStrip.Checked = True
                RadioBM.Checked = True
                Lbl_Diff.Text = "Diff: Media"
            Case Is = Difficoltà.Difficile
                Me.DifficileToolStrip.Checked = True
                RadioBD.Checked = True
                Lbl_Diff.Text = "Diff: Difficile"
            Case Is = Difficoltà.Molto_Difficile
                Me.MoltoDifficileToolStrip.Checked = True
                RadioBMoreD.Checked = True
                Lbl_Diff.Text = "Diff: Molto_Difficile"
        End Select

        Stato_eventi = Stato.Avviato
        InMovimento = False
        Me.ButtRivedi.Text = ""
        Me.ButtRivedi.BackgroundImage = My.Resources.buttRivediBW
        Me.ButtonAvvia.Enabled = True
        Me.ButtonAvvia.Text = "in play "
        TSLabel_Stato.Text = "Stato: Punteggio " & Punteggio & "   Mosse " & mosse
    End Sub

#End Region

#Region "Livelli"

    'modificato da Mikelius il 9-7-2018 alle 19

    ' Accomuna gli eventi dei vari ToolStripMenu
    Private Sub LivChoose_Click(sender As Object, e As EventArgs) Handles FacileToolStrip.Click,
    MediaToolStrip.Click, DifficileToolStrip.Click, MoltoDifficileToolStrip.Click

        LivChoose(sender.Tag)

    End Sub

    ' Accomuna gli eventi dei vari RadionButton
    Private Sub RadioLivel(sender As Object, e As EventArgs) Handles RadioBM.Click,
        RadioBMoreD.Click, RadioBD.Click, RadioBM.Click, RadioBF.Click

        LivChoose(sender.Tag)

    End Sub

    ' Funzione generale per la scelta livello
    Private Sub LivChoose(livello As Int32)

        If Not Stato_eventi = Stato.Azzerato Then
            Return
        Else
            Livello_Diff = livello
            Call Gestione_Difficolta_Livello(livello)
        End If
    End Sub


#End Region

End Class